Card = Object:extend()

function Card:new(card, creator, genre)
  self.name = card[1]
  self.health = card[2]
  self.cond = card[3]
  self.desc = card[4]
  self.effect = card.effect
  self.player = turn
  self.spawn = nil
  self.type = genre or "Card"
  self.id = (#board + 1) or id
  self.crea = (self.id - 1) or creator
  self.inside = 0
  self.x = -1
  self.y = -1
end

function Card:draw(loc)
	if self.cond == "S" then love.graphics.setColor(255, 255, 255, 255) end
  if self.cond == "D" then love.graphics.setColor(255, 0, 0, 255) end
  if self.cond == "H" then love.graphics.setColor(0, 255, 0, 255) end
  if self.cond == "P" then love.graphics.setColor(0, 0, 255, 255) end
  if self.cond == "K" then love.graphics.setColor(255, 255, 0, 255) end
  if loc == "h" then
    love.graphics.rectangle("fill", 72*id, 500 - self.inside, 70, 100)
    love.graphics.setColor(0, 0, 0, 255)
   	love.graphics.print(self.health, 72*id + 2, 502 - self.inside)
    love.graphics.print(self.name, 72*id + 5, 522 - self.inside)
    love.graphics.print(self.desc, 72*id + 2, 542 - self.inside, 0, 0.8, 0.8)
  elseif loc == "b" then
    love.graphics.rectangle("fill", 31*self.x, 31*self.y, 30, 30)
    love.graphics.setColor(0, 0, 0, 255)
    love.graphics.print(self.health, 31*self.x + 2, 31*self.y + 2, 0, 2, 2)
  end
end

--Play a card on the board
function Card:play(location, pos)
  local can = 0
  for i,v in ipairs(board) do
  end
  id = nil
  if location == Tokens then 
    table.insert(board, Card(Tokens[pos], self.id, "Token"))
    selecting = true
    selection = 1
  else 
    table.insert(board, location[pos]) 
    self.player = turn
    for y,row in ipairs(Tilemap) do
      for x,tile in ipairs(row) do
        --Put the played card on the right white spawning plateform
        if tile == 3 and can == 0 and turn == 1 then
          self.x = x
          self.y = y
          self.spawn = {y, x}
          Tilemap[y][x] = 4
          can = 1
        end
        if tile == 2 and can == 1 and turn == 1 then
          Tilemap[y][x] = 3
          can = 2
        end
        if tile == 6 and can == 0 and turn == 2 then
          self.x = x
          self.y = y
          self.spawn = {y, x}
          Tilemap[y][x] = 7
          can = 1
        end
        if tile == 5 and can == 1 and turn == 2 then
          Tilemap[y][x] = 6
          can = 2
        end
      end
    end
    if can == 0 then table.remove(board, #board) end
  end
  selCard = board[#board]
  if location == hands[turn] and can ~= 0 then table.remove(hands[turn], pos) end
  if selCard.cond == "S" and not selecting and can ~= 0 then selCard.effect() end
end

--Move the card in a direction until it hits something
function Card:move(dx, dy)
	if self.player == turn then
		local stop = false
		while not stop do
			self.x = self.x + dx
			self.y = self.y + dy
			stop = (self.x == 0 or self.x == 8 or self.y == 0 or self.y == 12 or Tilemap[self.y][self.x] == 1)
			for i,card in ipairs(board) do
				if card.x == self.x and card.y == self.y and card.name ~= self.name and not stop then 
					stop = (self.name ~= "Cyborg")
					if card.type == 'Card' and card.player ~= turn then
						self:deal(i, 1)
						if self.cond == "H" then self.effect() end
						card.y, card.x = unpack(card.spawn) 
					else 
						self:deal(i, 10) 
					end
				end
			end
		end
		self.x = self.x - dx
		self.y = self.y - dy
	end
end

--Deal damage to a card on the board
function Card:deal(victim, amount)
  local can = 0
  victimCard = victim
  selCard = self
  board[victim].health = board[victim].health - amount
  if board[victim].health <= 0 then
  	if board[victim].cond == "D" then board[victim].effect() end
  	if board[victim].type == "card" then
	    for y,row in ipairs(Tilemap) do
	      for x,tile in ipairs(row) do
	    	  if tile == 3 and board[victim].player == 1 then Tilemap[y][x] = 2 end
	    	  if tile == 6 and board[victim].player == 2 then Tilemap[y][x] = 5 end
	      end
	    end
	  end
	  for i,card in ipairs(board) do
	  	if card.crea > victim then card.crea = card.crea - 1 end
	  end
    if board[victim].spawn then Tilemap[board[victim].spawn[1]][board[victim].spawn[2]] = Tilemap[board[victim].spawn[1]][board[victim].spawn[2]] - 1 end
    table.remove(board, board[victim].id)
  end
end

--Swap two cards' position
function Card:swap(target)
  local x = self.x
  local y = self.y
  self.x = board[target].x
  self.y = board[target].y
  board[target].x = x
  board[target].y = y
end

function Card:teleport(x, y)
  self.x = x
  self.y = y
end