Object = require("Librairy/classic")
require("Librairy/card")

hands = {
	{},
	{}
}
board = {}
turn = 1
otherTurn = 2
mult = 0
font = love.graphics.getFont()

--[[
All cards are encoded like this :
{Name, Health, Effect trigger, Effect}
Effect triggers :
  "S" : Spawn
  "D" : Death
  "H" : Hit
  "K" : Kill
  "P" : Permanent (execute once time every start of your turn)

Tokens are cards that are spawned by characters. They're uncollectible. At the end of your turn, they take 1 damage. When they're attacked, they die instantly.
]]--

Tilemap = {
	{0, 3, 0, 2, 0, 2, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0},
	{0, 6, 0, 5, 0, 5, 0}
}

Deck = {
  {"Jetpack", 3, "S", "Spawn then \nmove to \nwherever you \nwant", effect = function() 
  	selecting = true 
  	selection = 1
  end},
  {"Engineer", 4, "D", "Spawn a \nTeleporter on \ndeath", effect = function() selCard:play(Tokens, 1) end}, --
  {"Magician", 4, "H", "Deal 1 damage \nto a random \ncard on the \nboard on hit", effect = function() selCard:deal(love.math.random(1, #board), 1) end},
  {"Pupeeter", 4, "S", "Spawn a \nPuppet on \nspawn", effect = function() selCard:play(Tokens, 2) end},
  {"Cyborg", 3, "P", "Go through \nenemies", effect = function() end},
  {"Medic", 3, "D", "Spawn a \nPoison Potion \non death", effect = function() selCard:play(Tokens, 4) end},
  {"Mechanic", 4, "S", " Spawn a \nMech on \nspawn", effect = function() selCard:play(Tokens, 3) end},
  {"Bomber", 4, "D", "Deal 1 damage \nto every card \non the board \non death", effect = function()
		for i,card in ipairs(board) do
			selCard:deal(i, 4)
		end
	end},
	{"Sapper", 3, "K", "Spawn a \nBomb on \nLegs on kill", effect = function() selCard:play(Tokens, 5) end},
	{"Citizen", 5, "P", "No effect, \njust a citizen", effect = function() end},
	{"Spy", 3, "S", "Can spawn on \nany spawning \nplateform", effect = function() 
		selecting = true
		selection = 3
	end}
}

Tokens = {
  {"Teleporter", 1, "D", "Create a \nspawning \nplateform on \ndeath", effect = function() Tilemap[selCard.y][selCard.x] =  3*selCard.player - 1 end}, 
  {"Puppet", 2, "D", "Heal his \ncreator by \n1 on \ndeath", effect = function() selCard:deal(selCard.crea, -1) end},
  {"Mech", 1, "D", "Swap with \nhis creator \non death", effect = function() selCard:swap(selCard.crea) end},
  {"Poison", 2, "P", "Deal 1 damage \nto the closest \ncard in a 3-tile \ndiameter each \nturn", effect = function()
  	char, dist = nearestCard(selCard)
  	if dist <= 1 then selCard:deal(char.id, 1) end
  end},
  {"BOL", 2, "H", "Deal 1 more \ndamage and \ndie on hit", effect = function()
  	selCard:deal(victimCard, 1)
  	selCard:deal(selCard.id, 2)
  end}
}

function love.load()
  draw(5, 1)
  draw(5, 2) --Draw the five cards for both players
  genTilemap(10) --Fulfill the tilemap with 10 walls
  selecting = false
  selection = 0
end

function love.update(dt)
	mousex, mousey = love.mouse.getPosition()
	for i,card in ipairs(board) do
		card.id = i
		card.crea = i - 1
	end
	if turn <= 2 then
		if not selecting then
			local size = #hands[turn]
			for i,card in ipairs(hands[turn]) do
				--Rise your cards when you hover them and play them when you click
				if pointInRectangle(mousex, mousey, 72*i, 500 - card.inside, 70, 100 + card.inside) then card.inside = 20 else card.inside = 0 end
				if card.inside == 20 and pressed1 then 
					pressed1 = false
					card:play(hands[turn], i)
					for i,card in ipairs(board) do
						card.id = i
						card.crea = i - 1
					end
					if not selecting and #hands[turn] ~= size then nextTurn() end
				end
			end
		else
			if pressed1 then 
				selCard:teleport(selectTile(selection))
				if selCard.cond == "S" and selCard.type == "Token" then selCard.effect() end
				if not selecting then nextTurn() end 
			end
		end
	end
end

function love.draw()
	love.graphics.push()
	-- I'll add later camera movement
	for y,row in ipairs(Tilemap) do
	 	for x,tile in ipairs(row) do
	 		--Draw the tilemap
	 		love.graphics.setColor(123, 123, 123, 255)
			if tile == 1 then love.graphics.rectangle("fill", 31*x, 31*y, 30, 30) end
			if tile % 3 == 0 then love.graphics.setColor(255, 255, 255, 255) end
			if tile % 3 == 1 then love.graphics.setColor(50, 50, 50, 255) end
			if tile >= 2 then love.graphics.rectangle("fill", 31*x + 7, 31*y + 7, 15, 15) end
		end
	end
	for y=0,12 do
	 	for x=0,8 do
	 		--Draw the borders
	 		love.graphics.setColor(50, 50, 50, 255)
	 		if y == 0 or y == 12 or x == 0 or x == 8 then love.graphics.rectangle("fill", 31*x, 31*y, 30, 30) end
	 	end
	end
	local shown = false
	for i,card in ipairs(board) do
		--Draw a little gray-green square behind the cards if they're yours
		love.graphics.setColor(123, 255, 123, 255)
		if card.player == turn then love.graphics.rectangle("fill", 31*card.x - 1, 31*card.y - 1, 32, 32) end
		--Draw the cards that are on the board
		card:draw("b")
		--Show the name and escritption of the card you're moving if you're selecting a spot
		love.graphics.setColor(255, 255, 255, 255)
		if selecting then
			mult = 1
			if selection == 1 then love.graphics.print("Select a tile!", 300, 0, 0, 2, 2) end
			if selection == 2 then love.graphics.print("Select a card!", 300, 0, 0, 2, 2) end
			if selection == 3 then love.graphics.print("Select a spawn plateform!", 300, 0, 0, 2, 2) end
			if math.floor(mousex/31) < 1 or math.floor(mousex/31) > 7 or math.floor(mousey/31) < 1 or math.floor(mousey/31) > 11 then love.graphics.setColor(255, 0, 0, 255) end
			love.graphics.rectangle("line", 31 * math.floor(mousex/31), 31 * math.floor(mousey/31), 30, 30)
			if selCard.cond == "S" then love.graphics.setColor(255, 255, 255, 255) end
			if selCard.cond == "D" then love.graphics.setColor(255, 0, 0, 255) end
			if selCard.cond == "H" then love.graphics.setColor(0, 255, 0, 255) end
			if selCard.cond == "P" then love.graphics.setColor(0, 0, 255, 255) end
			if selCard.cond == "K" then love.graphics.setColor(255, 255, 0, 255) end
		  love.graphics.rectangle("fill", mousex + 10, mousey + 10, 70*mult, 100*mult)
		  love.graphics.setColor(0, 0, 0, 255)
		  love.graphics.print(selCard.health .. "|" .. selCard.type .. "|" .. selCard.player, mousex + 12, mousey + 12, 0, mult, mult)
		  love.graphics.print(selCard.name, mousex + 15, mousey + 32, 0, mult, mult)
		  love.graphics.print(selCard.desc, mousex + 12, mousey + 52, 0, 0.8 * mult, 0.8 * mult)
		end
		--Show the name and description of a card when you hover it on the board
		if pointInRectangle(mousex, mousey, 31*card.x, 31*card.y, 30, 30) then
			if mult < 1 then mult = mult + 0.1 elseif mult > 1 then mult = 1 end
			if card.cond == "S" then love.graphics.setColor(255, 255, 255, 255) end
		  if card.cond == "D" then love.graphics.setColor(255, 0, 0, 255) end
		  if card.cond == "H" then love.graphics.setColor(0, 255, 0, 255) end
		  if card.cond == "P" then love.graphics.setColor(0, 0, 255, 255) end
		  if card.cond == "K" then love.graphics.setColor(255, 255, 0, 255) end
		  love.graphics.rectangle("fill", mousex + 10, mousey + 10, 70*mult, 100*mult)
		  love.graphics.setColor(0, 0, 0, 255)
		  love.graphics.print(card.health .. "|" .. card.type .. "|" .. card.player, mousex + 12, mousey + 12, 0, mult, mult)
		  love.graphics.print(card.name, mousex + 15, mousey + 32, 0, mult, mult)
		  love.graphics.print(card.desc, mousex + 12, mousey + 52, 0, 0.8*mult, 0.8*mult)
		  shown = true
		end
		--Show the direction you choose to move when you press a direction button
		if card.player == turn then
			love.graphics.setColor(255, 255, 255, 255)
			if pressed == 'w' then love.graphics.line(31*card.x+15, 31*card.y+15, 31*card.x+15, 31*card.y-15) end
			if pressed == 's' then love.graphics.line(31*card.x+15, 31*card.y+15, 31*card.x+15, 31*card.y+45) end
			if pressed == 'a' then love.graphics.line(31*card.x+15, 31*card.y+15, 31*card.x-15, 31*card.y+15) end
			if pressed == 'd' then love.graphics.line(31*card.x+15, 31*card.y+15, 31*card.x+45, 31*card.y+15) end
		end
	end
	if not shown then mult = 0 end
	if turn <= 2 then
		for i,card in ipairs(hands[turn]) do
		  --Draw the cards that are in your hand
		  id = i
			card:draw("h")
	  end
	else
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.print("Press a mouse button", 400 - font:getWidth("Press a mouse button"), 300 - font:getHeight(), 0, 2, 2)
		if pressed1 or pressed2 then nextTurn() end
	end
	love.graphics.pop()
  pressed1 = false
  pressed2 = false
end

function love.mousepressed(x, y, button)
	pressed1 = (button == 1)
	pressed2 = (button == 2)
	if button == 3 then
		local response = {}
		for i,card in ipairs(board) do
			table.insert(response, card.name)
		end
		print(unpack(response))
		print(#response)
	end
end

function love.keypressed(key, scan)
	pressed = scan
end

function love.keyreleased(key, scan)
	if not love.keyboard.isScancodeDown('w', 's', 'd', 'a') then
		for i,card in ipairs(board) do
			if pressed == 'w' then card:move(0, -1) end
			if pressed == 's' then card:move(0, 1) end
			if pressed == 'a' then card:move(-1, 0) end
			if pressed == 'd' then card:move(1, 0) end
		end
		if turn <= 2 then nextTurn() end
	end
end

function genTilemap(amount)
	local nb = amount
	for y,row in ipairs(Tilemap) do
  	for x,tile in ipairs(row) do
  		--Fulfill the tilemap
  		local isFull = love.math.random(1, 20)
  		if isFull == 1 and tile == 0 and nb > 0 and y ~= 1 and y ~= 11 then
  			Tilemap[y][x] = 1
  			nb = nb - 1
  		end
  	end
  end
  if nb > 0 then genTilemap(nb) end
end

--Draw cards
function draw(amount, player)
  for i=1,amount do
  	id = i
    local drawn = love.math.random(1, #Deck)
    table.insert(hands[player], Card(Deck[drawn]))
    table.remove(Deck, drawn)
  end
end

function nearestCard(card)
	local x = card.x
	local y = card.y
	local dist = 1000
	local nearest = nil

	for i,v in ipairs(board) do
		if math.sqrt((x - v.x)^2 + (y - v.y)^2) < dist then 
			dist = math.sqrt((x - v.x)^2 + (y - v.y)^2) 
			nearest = v
		end
	end
	return nearest, dist
end

function selectTile(selection)
	local tilex = math.floor(mousex/31)
	local tiley = math.floor(mousey/31)
	if tiley > 0 and tiley < 12 and tilex > 0 and tilex < 8 then
		local tile = Tilemap[tiley][tilex]
		local wrong = not(Tilemap[tiley][tilex] == 0 and selection ~= 3 or Tilemap[tiley][tilex] >= 2 and selection == 3)
		for i,card in ipairs(board) do
			if card.x == tilex and card.y == tiley and i ~= #board then 
				wrong = true 
				local selCard = card
			end
		end
		selecting = false
		if not wrong and selection == 1 then return tilex, tiley elseif selection == 2 then return selCard elseif selection == 3 and not wrong then return tilex, tiley else
			selecting = true
			return selCard.x, selCard.y
		end
	else
		return selCard.x, selCard.y
	end
end

function pointInRectangle(pointx, pointy, rectx, recty, rectw, recth) 
	return pointx > rectx and pointx < rectx + rectw and pointy > recty and pointy < recty + recth 
end

function nextTurn()
	pressed1 = false
	pressed2 = false
	pressed = nil
	turn = turn + 2
	if turn > 4 then 
		if turn == 5 then turn = 2 else turn = 1 end
		for i,card in ipairs(board) do
			if card.player == turn then 
				if card.cond == "P" then card.effect() end
				if card.type == "Token" then card:deal(i, 1) end
			end
		end
	end
	otherTurn = otherTurn + 1
	if otherTurn == 3 then otherTurn = 1 end
end